Edu144 CD

Dashboard - Educational Codeforces Round 144 (Rated for Div. 2) - Codeforces

C. Maximum Set

思路:要想让集合长度最长,显然令倍数为2,那么可以容易得到最长长度为 l o g 2 ( r / l ) + 1 log2(r/l)+1 log2(r/l)+1。

接下来求个数,首先是所有倍数都为2的集合,上界为 u p = r / ( 1 l l < < c i ) up = r / (1ll << ci) up=r/(1ll<<ci), a n s 1 = ( u p − l + 1 ) ans1=(up - l + 1) ans1=(up−l+1)。

其次可以令一个2变成3,比如第四个样例,4 8 16 32 64--->>>4 12 24 48 96。第二个位置2变3。

我们求出这种情况的上界 u p 1 = r / ( 1 l l < < ( c i − 1 ) ) / 3 up1 = r / (1ll << (ci - 1)) / 3 up1=r/(1ll<<(ci−1))/3, a n s 2 = ( u p 1 − l + 1 ) ∗ c i ) ans2=(up1 - l + 1) * ci) ans2=(up1−l+1)∗ci)。

然后如果两个2变成3或者一个2变成4,都会导致长度变短所以不可行。

所以最终答案 a n s = ( a n s 1 + a n s 2 ) ans=(ans1+ans2)%mod ans=(ans1+ans2)。

cpp 复制代码
void solve()
{
    int l, r;
    cin >> l >> r;
    int len = log2(r / l) + 1;
    int ci = log2(r / l);//2的个数
    int up = r / (1ll << ci); // 第一个上界
    ans = 0;
    ans += (up - l + 1);
    /* cout << up << ' '; */
    int up1 = r / (1ll << (ci - 1)) / 3; // 第二个上界
    if (up1 - l + 1 > 0)
    {
        ans = (ans + (up1 - l + 1) * ci) % mod; //*ci是因为这种情况所有的2都可以变成3
    }
    cout << len << ' ' /*  << up << ' ' << x << ' ' */;
    cout << ans;
}

D. Maximum Subarray

思路:题目要求k个数+x,其他数-x。我们可以先令所有数-x,再选k个数+2*x。

我们考虑 d p i j dpij dpij 为前i个数选了j个数,容易得到转移方程:

d p i j = m a x ( d p i − 1 j + a i , d p i − 1 j − 1 + a i + x ∗ 2 , 0 l l ) dpij=max(dpi-1j+ai,dpi-1j-1+ai+x*2,0ll) dpij=max(dpi−1j+ai,dpi−1j−1+ai+x∗2,0ll) 。

cpp 复制代码
void solve()
{
    cin >> n >> k >> x;
    rep(1, i, n)
    {
        cin >> a[i];
        a[i] -= x;
    }
    rep(0, i, n)
    {
        rep(i + 1, j, k)
        {
            dp[i][j] = -1e18;
        }
    }
    ans = 0;
    rep(1, i, n)
    {
        rep(0, j, min(i, k))
        {
            if (j)
            {
                dp[i][j] = max({dp[i - 1][j] + a[i], dp[i - 1][j - 1] + a[i] + 2 * x, 0ll});
            }
            else
            {
                dp[i][j] = max(dp[i - 1][j] + a[i], 0ll);
            }
        }
    }
    rep(1, i, n)
    {
        rep(0, j, min(i, k))
        {
            if (k - j <= n - i) //注意确保没选的k的个数要小于等于当前未选的总数
            {
                ans = max(ans, dp[i][j]);
            }
        }
    }
    cout << ans;
}
相关推荐
dialect_2 小时前
KMP算法
开发语言·c++·算法
reikocao2 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz2 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·3 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
ShineWinsu3 小时前
对于Qt:QRadioButton常见属性以及QButtonGroup的解析
数据库·c++·qt·microsoft·gui·qradiobutton·qbuttongroup
傲世仙尊4 小时前
多态-虚表才活到运行期符号表早已消失
c++
chenbingjie_c4 小时前
C++ 多态完全指南:从虚函数重写到虚函数表原理
开发语言·c++
是main不是漫4 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
·present·4 小时前
CSAPP(Bomb lab)
c语言·c++
王老师青少年编程4 小时前
2026年信奥赛c++普及组csp-j第二轮复赛真题
c++·真题·csp·信奥赛